package com.unis.auth.utils;

import com.trs.idm.util.StringHelper;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.codec.binary.Base64;
import org.apache.http.HttpEntity;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.util.*;

@Slf4j
public class IdsUtilForClient {

	static String desKey="123456789";

	public static String receive(String str,String desKey) throws NoSuchAlgorithmException, IOException{
	    //  拆分摘要和结果信息
	    String[] digestAndResult = str.split("&");
	    String digestOfServer = digestAndResult[0]; 
	    String result = digestAndResult[1];
	    //  解密响应结果 
	    String afterDESResult = DESUtil.decryptToHex(desKey,result);
	    String afterBase64Decode=new String(Base64Data.decode(LockUtil.decodeHex(afterDESResult)),"UTF-8");
	    MessageDigest sd = MessageDigest.getInstance("MD5"); 
	    sd.update(afterBase64Decode.getBytes("UTF-8"));
	    String digestOfAgent = StringHelper.toString(sd.digest());
	    if(digestOfServer.equals(digestOfAgent)){
	    	return afterBase64Decode;
	    }else{
	    	return null;
	    }
	}

	/**
	 * 用HttpClient向指定URL发送POST方法的请求
	 * @param url 发送请求的URL
	 * @param  formparams
	 * @return InputStream 所代表远程资源的响应结果
	 */
	public static String httpClientPost(String url,List<NameValuePair> formparams){
		// 创建默认的httpClient实例.
		CloseableHttpClient httpclient = HttpClients.createDefault();
		// 创建httppost
		HttpPost httppost = new HttpPost(url);
		UrlEncodedFormEntity uefEntity;
		try {
			uefEntity = new UrlEncodedFormEntity(formparams, "UTF-8");
			httppost.setEntity(uefEntity);
			System.out.println("executing request " + httppost.getURI());
			CloseableHttpResponse response = httpclient.execute(httppost);
			try {
				HttpEntity entity = response.getEntity();
				if (entity != null) {
					return EntityUtils.toString(entity, "UTF-8");
				}
			} finally {
				response.close();
			}
		} catch (ClientProtocolException e) {
			e.printStackTrace();
		} catch (UnsupportedEncodingException e1) {
			e1.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			// 关闭连接,释放资源
			try {
				httpclient.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return null;
	}

	static class DESUtil {
		//DES/ECB/PKCS5Padding
		//DES/ECB/NoPadding
		private final static String DES = "DES";
		private final static String DES_INSTANCE = "DES/ECB/PKCS5Padding";
		private static String hexString = "0123456789ABCDEF";

		/**
		 * Description 根据键值进行加密
		 *
		 * @param data
		 * @param key  加密键byte数组
		 * @return
		 * @throws Exception
		 */
		public static String encrypt(String key, String data) {
			byte[] bt;
			try {
				bt = encrypt(data.getBytes(), key.getBytes());
				return Base64Data.encode(bt);
			} catch (Exception e) {
				e.printStackTrace();
			}
			return null;
		}

		/**
		 * Description 根据键值进行解密
		 *
		 * @param data
		 * @param key  加密键byte数组
		 * @return
		 * @throws IOException
		 * @throws Exception
		 */
		public static String decrypt(String key, String data) {
			if (data == null)
				return null;
			byte[] bt;
			byte[] buf;
			try {
				buf = Base64Data.decode(data);
				bt = decrypt(buf, key.getBytes());
				return new String(bt);
			} catch (IOException e) {
				e.printStackTrace();
			} catch (Exception e) {
				e.printStackTrace();
			}
			return null;
		}

		/**
		 * Description 根据键值进行加密
		 *
		 * @param data
		 * @param key  加密键byte数组
		 * @return
		 * @throws Exception
		 */
		private static byte[] encrypt(byte[] data, byte[] key) throws Exception {
			// 生成一个可信任的随机数源
			SecureRandom sr = new SecureRandom();

			// 从原始密钥数据创建DESKeySpec对象
			DESKeySpec dks = new DESKeySpec(key);

			// 创建一个密钥工厂，然后用它把DESKeySpec转换成SecretKey对象
			SecretKeyFactory keyFactory = SecretKeyFactory.getInstance(DES);
			SecretKey securekey = keyFactory.generateSecret(dks);

			// Cipher对象实际完成加密操作
			Cipher cipher = Cipher.getInstance(DES_INSTANCE);

			// 用密钥初始化Cipher对象
			cipher.init(Cipher.ENCRYPT_MODE, securekey, sr);

			return cipher.doFinal(data);
		}


		/**
		 * Description 根据键值进行解密
		 *
		 * @param data
		 * @param key  加密键byte数组
		 * @return
		 * @throws Exception
		 */
		private static byte[] decrypt(byte[] data, byte[] key) throws Exception {
			// 生成一个可信任的随机数源
			SecureRandom sr = new SecureRandom();

			// 从原始密钥数据创建DESKeySpec对象
			DESKeySpec dks = new DESKeySpec(key);

			// 创建一个密钥工厂，然后用它把DESKeySpec转换成SecretKey对象
			SecretKeyFactory keyFactory = SecretKeyFactory.getInstance(DES);
			SecretKey securekey = keyFactory.generateSecret(dks);

			// Cipher对象实际完成解密操作
			Cipher cipher = Cipher.getInstance(DES_INSTANCE);

			// 用密钥初始化Cipher对象
			cipher.init(Cipher.DECRYPT_MODE, securekey, sr);

			return cipher.doFinal(data);
		}

		/**
		 * Description 根据键值加密成16进制
		 *
		 * @param data
		 * @param key  加密键byte数组
		 * @return
		 * @throws Exception
		 */
		public static String encryptToHex(String key, String data) {
			return encryptToHex(key, decodeHex(data));
		}

		/**
		 * Description 根据键值加密成16进制
		 *
		 * @param key         加密键byte数组
		 * @param encrtptData
		 * @return
		 * @throws Exception
		 */
		public static String encryptToHex(String key, byte[] encrtptData) {
			byte[] bt;
			try {
				bt = encrypt(encrtptData, key.getBytes());
				return encodeHex(bt);
			} catch (Exception e) {
				e.printStackTrace();
			}
			return null;
		}


		/**
		 * Description 根据键值解密成16进制
		 *
		 * @param data
		 * @param key  加密键byte数组
		 * @return
		 * @throws IOException
		 * @throws Exception
		 */
		public static String decryptToHex(String key, String data) {
			return decryptToHex(key, decodeHex(data));
		}

		/**
		 * Description 根据键值解密成16进制
		 *
		 * @param key 加密键byte数组
		 * @param buf
		 * @return
		 * @throws IOException
		 * @throws Exception
		 */
		public static String decryptToHex(String key, byte[] buf) {
			byte[] bt;
			try {
				bt = decrypt(buf, key.getBytes());
				return encodeHex(bt);
			} catch (IOException e) {
				e.printStackTrace();
			} catch (Exception e) {
				e.printStackTrace();
			}
			return null;
		}

		public static final String bytesToHex(byte[] buf) {
			int len = buf.length;
			char[] out = new char[len * 2];
			for (int i = 0, j = 0; i < len; i++) {
				int a = buf[i];
				out[(j++)] = Character.forDigit(a >>> 4 & 0xF, 16);
				out[(j++)] = Character.forDigit(a & 0xF, 16);
			}
			return new String(out);
		}

		/**
		 * trs将字节数组编码成字符串
		 *
		 * @return String
		 * @throws null
		 * @author lipenghe
		 */
		public static String encodeHex(byte[] data) {
			int l = data.length;
			char[] out = new char[l << 1];
			int i = 0;
			for (int j = 0; i < l; i++) {
				out[(j++)] = hexString.charAt(((0xF0 & data[i]) >>> 4));
				out[(j++)] = hexString.charAt((0xF & data[i]));
			}
			return new String(out);
		}

		/**
		 * trs将对应的16进制数字解码成字节数组
		 *
		 * @return String
		 * @throws null
		 * @author lipenghe
		 */
		public static byte[] decodeHex(String str) {
			char[] data = str.toCharArray();
			int len = data.length;
			byte[] out = new byte[len >> 1];
			for (int j = 0, i = 0; j < len; i++) {
				int f = Character.digit(data[j], 16) << 4;
				j++;
				f |= Character.digit(data[j], 16);
				j++;
				out[i] = (byte) (f & 0xFF);
			}
			return out;
		}
	}
		static class LockUtil {
			private static String hexString = "0123456789ABCDEF";

			/**
			 * 将字符串编码成UTF-8 对应的16进制数字,适用于所有字符（包括中文）
			 * @author lipenghe
			 * @return String
			 * @throws null
			 */
			public static String encodeHex(String str) {
				// 根据默认编码获取字节数组
				byte[] bytes = str.getBytes();
				StringBuilder sb = new StringBuilder(bytes.length * 2);
				// 将字节数组中每个字节拆解成2位16进制整数
				for (int i = 0,len=bytes.length; i <len ; i++) {
					sb.append(hexString.charAt((bytes[i] & 0xf0) >> 4));
					sb.append(hexString.charAt((bytes[i] & 0x0f) >> 0));
				}
				return sb.toString();
			}

			/**
			 * 将字节数组编码成UTF-8 对应的16进制数字,适用于所有字符（包括中文）
			 * @author lipenghe
			 * @return String
			 * @throws null
			 */
			public static String encodeHex(byte[] data){
				int l = data.length;
				char[] out = new char[l << 1];
				int i = 0;
				for (int j = 0; i < l; i++) {
					out[(j++)] = hexString.charAt(((0xF0 & data[i]) >>> 4));
					out[(j++)] = hexString.charAt((0xF & data[i]));
				}
				return new String(out);
			}

			/**
			 * 将UTF-8对应的16进制数字解码成字符串,适用于所有字符（包括中文）
			 * @author lipenghe
			 * @return String
			 * @throws null
			 */
			public static String decodeHex(String str) {
				if(str==null){
					return "";
				}
				int len=str.length();
				ByteArrayOutputStream baos = new ByteArrayOutputStream(len / 2);
				// 将每2位16进制整数组装成一个字节
				for (int i = 0; i < len; i += 2){
					baos.write((hexString.indexOf(str.charAt(i)) << 4 | hexString.indexOf(str.charAt(i + 1))));
				}
				return new String(baos.toByteArray());
			}

			/**
			 * 转化字符串为Unicode对应的十六进制编码 (Unicode big endian 也即是大头, FE FF ;与之对应的是小头  ,FF FE )
			 * @author lipenghe
			 * @return String
			 * @throws null
			 */
			public static String strToHex(String s) {
				if(s==null){
					return "";
				}
				StringBuffer sb=null;
				sb=new StringBuffer();
				int len=s.length();
				int index;
				for (int i = 0; i < len; i++) {
					index=s.charAt(i);
					if(index<=127){
						sb.append("00");
					}
					sb.append(Integer.toHexString(index).toUpperCase());
				}
				return sb.toString();
			}

			/**
			 * base64转正常码
			 * @author lipenghe
			 * @param str
			 * @return String
			 */
			public static String base64ToStr(String str) {
				if(str == null){
					return "";
				}else{
					try {
						return new String(Base64Data.decode(str),"UTF-8");
					} catch (IOException e) {
						e.printStackTrace();
					}
					return "";
				}
			}

			/**
			 * 正常码转base64
			 * @author lipenghe
			 * @param str
			 * @return String
			 */
			public static String strToBase64(String str) {
				if(str == null){
					return "";
				}else{
					try {
						return Base64Data.encode(str.getBytes("UTF-8"));
					} catch (UnsupportedEncodingException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					return "";
				}
			}
		}

	static class Base64Data {
		/**
		 * Base64编码表。
		 */
		private static final char[] BASE64CODE =
				{'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V'
						,'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q'
						,'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/'};

		/**
		 * Base64解码表。
		 */
		private static final byte[] BASE64DECODE =
				{-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1
						,-1, -1, -1
						,-1
						,-1 // 注意两个63，为兼容SMP，
						,-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, -1, 63
						,-1
						,63// “/”和“-”都翻译成63。
						,52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -1, -1, -1, 0, -1, -1, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11
						,12, 13
						,14// 注意两个0：
						,15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, -1, -1, -1, -1
						,-1// “A”和“=”都翻译成0。
						,-1, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51
						,-1, -1, -1, -1, -1};

		private static final int HEX_255 = 0x0000ff;

		private static final int HEX_16515072 = 0xfc0000;

		private static final int HEX_258048 = 0x3f000;

		private static final int HEX_4032 = 0xfc0;

		private static final int HEX_63 = 0x3f;

		private static final int HEX_16711680 = 0xff0000;

		private static final int HEX_65280 = 0x00ff00;

		private static final int NUMBER_TWO = 2;

		private static final int NUMBER_THREE = 3;

		private static final int NUMBER_FOUR = 4;

		private static final int NUMBER_SIX = 6;

		private static final int NUMBER_EIGHT = 8;

		private static final int NUMBER_TWELVE = 12;

		private static final int NUMBER_SIXTEEN = 16;

		private static final int NUMBER_EIGHTEEN = 18;

		/**
		 * 构造方法私有化，防止实例化。
		 */
		private Base64Data()
		{
		}

		/**
		 * Base64编码。将字节数组中字节3个一组编码成4个可见字符。
		 *
		 * @param b
		 *            需要被编码的字节数据。
		 * @return 编码后的Base64字符串。
		 */
		public static String encode(byte[] b)
		{
			int code = 0;

			// 按实际编码后长度开辟内存，加快速度
			StringBuffer sb = new StringBuffer(((b.length - 1) / NUMBER_THREE) << NUMBER_TWO + NUMBER_FOUR);

			// 进行编码
			for (int i = 0; i < b.length; i++)
			{
				code |=
						(b[i] << (NUMBER_SIXTEEN - i % NUMBER_THREE * NUMBER_EIGHT))
								& (HEX_255 << (NUMBER_SIXTEEN - i % NUMBER_THREE * NUMBER_EIGHT));
				if (i % NUMBER_THREE == NUMBER_TWO || i == b.length - 1)
				{
					sb.append(BASE64CODE[(code & HEX_16515072) >>> NUMBER_EIGHTEEN]);
					sb.append(BASE64CODE[(code & HEX_258048) >>> NUMBER_TWELVE]);
					sb.append(BASE64CODE[(code & HEX_4032) >>> NUMBER_SIX]);
					sb.append(BASE64CODE[code & HEX_63]);
					code = 0;
				}
			}

			// 对于长度非3的整数倍的字节数组，编码前先补0，编码后结尾处编码用=代替，
			// =的个数和短缺的长度一致，以此来标识出数据实际长度
			if (b.length % NUMBER_THREE > 0)
			{
				sb.setCharAt(sb.length() - 1, '=');
			}
			if (b.length % NUMBER_THREE == 1)
			{
				sb.setCharAt(sb.length() - NUMBER_TWO, '=');
			}
			return sb.toString();
		}

		/**
		 * Base64解码。
		 *
		 * @param code
		 *            用Base64编码的ASCII字符串
		 * @return 解码后的字节数据
		 */
		public static byte[] decode(String code)
		{
			// 检查参数合法性
			if (code == null)
			{
				return null;
			}
			int len = code.length();
			if (len % NUMBER_FOUR != 0)
			{
				throw new IllegalArgumentException("Base64 string length must be 4*n");
			}
			if (code.length() == 0)
			{
				return new byte[0];
			}

			// 统计填充的等号个数
			int pad = 0;
			if (code.charAt(len - 1) == '=')
			{
				pad++;
			}
			if (code.charAt(len - NUMBER_TWO) == '=')
			{
				pad++;
			}

			// 根据填充等号的个数来计算实际数据长度
			int retLen = len / NUMBER_FOUR * NUMBER_THREE - pad;

			// 分配字节数组空间
			byte[] ret = new byte[retLen];

			// 查表解码
			char ch1, ch2, ch3, ch4;
			int i;
			for (i = 0; i < len; i += NUMBER_FOUR)
			{
				int j = i / NUMBER_FOUR * NUMBER_THREE;
				ch1 = code.charAt(i);
				ch2 = code.charAt(i + 1);
				ch3 = code.charAt(i + NUMBER_TWO);
				ch4 = code.charAt(i + NUMBER_THREE);
				int tmp =
						(BASE64DECODE[ch1] << NUMBER_EIGHTEEN) | (BASE64DECODE[ch2] << NUMBER_TWELVE)
								| (BASE64DECODE[ch3] << NUMBER_SIX) | (BASE64DECODE[ch4]);
				ret[j] = (byte)((tmp & HEX_16711680) >> NUMBER_SIXTEEN);
				if (i < len - NUMBER_FOUR)
				{
					ret[j + 1] = (byte)((tmp & HEX_65280) >> NUMBER_EIGHT);
					ret[j + NUMBER_TWO] = (byte)((tmp & HEX_255));

				}
				else
				{
					if (j + 1 < retLen)
					{
						ret[j + 1] = (byte)((tmp & HEX_65280) >> NUMBER_EIGHT);
					}
					if (j + NUMBER_TWO < retLen)
					{
						ret[j + NUMBER_TWO] = (byte)((tmp & HEX_255));
					}
				}
			}
			return ret;
		}
	}

	/**
	 * @author LPH,查询用户在ids的应用的权限(允许访问的或不允许访问的)
	 * @param host
	 * @param appName
	 * @param desKey
	 * @param userName
	 * @return
	 * @throws NoSuchAlgorithmException
	 * @throws UnsupportedEncodingException
	 */
	public static String queryUserAppPermit(String host,String desKey,String appName,String type,String qType,String userName) throws NoSuchAlgorithmException, UnsupportedEncodingException{
		// 1、将所有参数以key-value的形式拼成整串，内隔符分别为=外分隔符&。
		StringBuffer sb=new StringBuffer(100);
		sb.append("userName=").append(userName).append("&groupName=").append("123").append("&qType=").append(qType).append("&manageRequest=Y");
		String data=sb.toString();
		// 2、根据整串生成摘要签名
		MessageDigest md = MessageDigest.getInstance("MD5");
		md.update(data.getBytes("UTF-8"));
		byte[] digestByte = md.digest();
		// 2-1）将生成的摘要转成16进制数表示
		//String digest = DESUtil.encodeHex(digestByte);
		String digest = DESUtil.bytesToHex(digestByte);
		// 3、对整串进行加密处理
		// 3-1）对整串做base64编码（去编码化）
		String base64Encoded = new String(Base64.encodeBase64(data.getBytes("UTF-8")));
		// 3-3）对data进行加密处理  并将结果转换成16进制表示
		String dataAfterDESEncode = DESUtil.encryptToHex(desKey,base64Encoded.getBytes("UTF-8"));
		// 4、将摘要签名和加密后的参数拼接成最终提交IDS的参数
		String finalData = digest+"&"+dataAfterDESEncode;
		String url=host+"/service?idsServiceType=remoteapi&method=qUserApplications";
		List<NameValuePair> formparams=new ArrayList<NameValuePair>();
		formparams.add(new BasicNameValuePair("appName",appName));
		formparams.add(new BasicNameValuePair("type",type));
		formparams.add(new BasicNameValuePair("version","5.0"));
		formparams.add(new BasicNameValuePair("data",finalData));
		return httpClientPost(url, formparams);
	}

	/**
	 * @author LPH,查询ids全部应用
	 * @param host
	 * @param appName
	 * @param desKey
	 * @return
	 * @throws NoSuchAlgorithmException
	 * @throws UnsupportedEncodingException
	 */
	public static String queryAllApp(String host,String desKey,String appName,String type) throws NoSuchAlgorithmException, UnsupportedEncodingException{
		// 1、将所有参数以key-value的形式拼成整串，内隔符分别为=外分隔符&。
		StringBuffer sb=new StringBuffer(100);
		String data=sb.toString();
		// 2、根据整串生成摘要签名
		MessageDigest md = MessageDigest.getInstance("MD5");
		md.update(data.getBytes("UTF-8"));
		byte[] digestByte = md.digest();
		// 2-1）将生成的摘要转成16进制数表示
		//String digest = DESUtil.encodeHex(digestByte);
		String digest = DESUtil.bytesToHex(digestByte);
		// 3、对整串进行加密处理
		// 3-1）对整串做base64编码（去编码化）
		String base64Encoded = new String(Base64.encodeBase64(data.getBytes("UTF-8")));
		// 3-3）对data进行加密处理  并将结果转换成16进制表示
		String dataAfterDESEncode = DESUtil.encryptToHex(desKey,base64Encoded.getBytes("UTF-8"));
		// 4、将摘要签名和加密后的参数拼接成最终提交IDS的参数
		String finalData = digest+"&"+dataAfterDESEncode;
		String url=host+"/service?idsServiceType=remoteapi&method=qApplications";
		List<NameValuePair> formparams=new ArrayList<NameValuePair>();
		formparams.add(new BasicNameValuePair("appName",appName));
		formparams.add(new BasicNameValuePair("type",type));
		formparams.add(new BasicNameValuePair("version","5.0"));
		formparams.add(new BasicNameValuePair("data",finalData));
		return httpClientPost(url, formparams);
	}

	/**
	 * @author LPH,新增用户
	 * @param host
	 * @param desKey
	 * @param appName
	 * @param type
	 * @param map
	 * @return
	 * @throws NoSuchAlgorithmException
	 * @throws UnsupportedEncodingException
	 */
	public static String addUser(String host,String desKey,String appName,String type,Map<String,Object> map) throws NoSuchAlgorithmException, UnsupportedEncodingException{
		// 1、将所有参数以key-value的形式拼成整串，内隔符分别为=外分隔符&。
		StringBuffer sb=new StringBuffer(100);
		if(map!=null){
			Iterator<Map.Entry<String,Object>> it=map.entrySet().iterator();
			Map.Entry<String,Object> entry=null;
			while(it.hasNext()){
				entry=it.next();
				sb.append(entry.getKey())
					.append("=")
					.append(entry.getValue())
					.append("&");
			}
			int len=sb.length();
			if(sb.lastIndexOf("&")==len-1){
				sb.deleteCharAt(len-1);
			}
		}
		String data=sb.toString();
		// 2、根据整串生成摘要签名
		MessageDigest md = MessageDigest.getInstance("MD5");
		md.update(data.getBytes("UTF-8"));
		byte[] digestByte = md.digest();
		// 2-1）将生成的摘要转成16进制数表示
		//String digest = DESUtil.encodeHex(digestByte);
		String digest = DESUtil.bytesToHex(digestByte);
		// 3、对整串进行加密处理
		// 3-1）对整串做base64编码（去编码化）
		String base64Encoded = new String(Base64.encodeBase64(data.getBytes("UTF-8")));
		// 3-3）对data进行加密处理  并将结果转换成16进制表示
		String dataAfterDESEncode = DESUtil.encryptToHex(desKey,base64Encoded.getBytes("UTF-8"));
		// 4、将摘要签名和加密后的参数拼接成最终提交IDS的参数
		String finalData = digest+"&"+dataAfterDESEncode;
		String url=host+"/service?idsServiceType=remoteapi&method=userRegister";
		List<NameValuePair> formparams=new ArrayList<NameValuePair>();
		formparams.add(new BasicNameValuePair("type",type));
		formparams.add(new BasicNameValuePair("appName",appName));
		formparams.add(new BasicNameValuePair("version","5.0"));
		formparams.add(new BasicNameValuePair("data",finalData));
		return httpClientPost(url, formparams);
	}

	/**
	 * @author LPH,管理员修改用户
	 * @param host
	 * @param desKey
	 * @param appName
	 * @param type
	 * @param map
	 * @return
	 * @throws NoSuchAlgorithmException
	 * @throws UnsupportedEncodingException
	 */
	public static String editUserManager(String host,String desKey,String appName,String type,Map<String,Object> map) throws NoSuchAlgorithmException, UnsupportedEncodingException{
		// 1、将所有参数以key-value的形式拼成整串，内隔符分别为=外分隔符&。
		StringBuffer sb=new StringBuffer(100);
		if(map!=null){
			Iterator<Map.Entry<String,Object>> it=map.entrySet().iterator();
			Map.Entry<String,Object> entry=null;
			while(it.hasNext()){
				entry=it.next();
				sb.append(entry.getKey())
						.append("=")
						.append(entry.getValue())
						.append("&");
			}
			int len=sb.length();
			if(sb.lastIndexOf("&")==len-1){
				sb.deleteCharAt(len-1);
			}
		}
		String data=sb.toString();
		// 2、根据整串生成摘要签名
		MessageDigest md = MessageDigest.getInstance("MD5");
		md.update(data.getBytes("UTF-8"));
		byte[] digestByte = md.digest();
		// 2-1）将生成的摘要转成16进制数表示
		//String digest = DESUtil.encodeHex(digestByte);
		String digest = DESUtil.bytesToHex(digestByte);
		// 3、对整串进行加密处理
		// 3-1）对整串做base64编码（去编码化）
		String base64Encoded = new String(Base64.encodeBase64(data.getBytes("UTF-8")));
		// 3-3）对data进行加密处理  并将结果转换成16进制表示
		String dataAfterDESEncode = DESUtil.encryptToHex(desKey,base64Encoded.getBytes("UTF-8"));
		// 4、将摘要签名和加密后的参数拼接成最终提交IDS的参数
		String finalData = digest+"&"+dataAfterDESEncode;
		String url=host+"/service?idsServiceType=remoteapi&method=userManageService";
		List<NameValuePair> formparams=new ArrayList<NameValuePair>();
		formparams.add(new BasicNameValuePair("type",type));
		formparams.add(new BasicNameValuePair("manageServiceTag","managerUpdateUser"));
		formparams.add(new BasicNameValuePair("appName",appName));
		formparams.add(new BasicNameValuePair("version","5.0"));
		formparams.add(new BasicNameValuePair("data",finalData));
		return httpClientPost(url, formparams);
	}

	/**
	 * 查询用户在ids的应用的权限(允许访问的或不允许访问的)
	 * @throws IOException
	 * @throws NoSuchAlgorithmException
	 */
	public static String currentQueryUserAppPermit(String userName) throws IOException, NoSuchAlgorithmException {
		Properties properties=new Properties();
		try{
			properties.load(IdsUtilForClient.class.getClassLoader().getResourceAsStream("trsids-agent.properties"));
		}catch (IOException	 e){
			log.info("------ids配置文件不存在------");
		}
		if(properties!=null){
			String host=properties.getProperty("protocol.http.url");
			host=host.replace("/protocol","");
			String appName=properties.getProperty("agent.name");

			//取值为Y时，表示查询允许访问的协作应用集合；取值为N时，表示查询不允许访问的协作应用集合
			String qType="Y";
			String type="json";
			String rev=queryUserAppPermit(host,desKey,appName,type,qType,userName);
			//System.out.println("res:"+receive(rev,desKey));
			return receive(rev, desKey);
		}
		return "{}";
	}

	/**
	 * 查询全部ids应用
	 * @throws IOException
	 * @throws NoSuchAlgorithmException
	 */
	public static String currentQueryAllApp() throws IOException, NoSuchAlgorithmException {
		Properties properties=new Properties();
		try{
			properties.load(IdsUtilForClient.class.getClassLoader().getResourceAsStream("trsids-agent.properties"));
		}catch (IOException	 e){
			log.info("------ids配置文件不存在------");
		}
		if(properties!=null){
			String host=properties.getProperty("protocol.http.url");
			host=host.replace("/protocol","");
			String appName=properties.getProperty("agent.name");

			//取值为Y时，表示查询允许访问的协作应用集合；取值为N时，表示查询不允许访问的协作应用集合
			String json="json";
			String rev=queryAllApp(host,desKey,appName,json);
			//System.out.println("res:"+receive(rev,desKey));
			return receive(rev, desKey);
		}
		return "{}";
	}

	/**
	 * 新增用户
	 * @throws IOException
	 * @throws NoSuchAlgorithmException
	 */
	public static String currentAddUser(Map<String,Object> userMap) throws IOException, NoSuchAlgorithmException {
		Properties properties=new Properties();
		try{
			properties.load(IdsUtilForClient.class.getClassLoader().getResourceAsStream("trsids-agent.properties"));
		}catch (IOException	 e){
			log.info("------ids配置文件不存在------");
		}
		if(properties!=null){
			String host=properties.getProperty("protocol.http.url");
			host=host.replace("/protocol","");
			String appName=properties.getProperty("agent.name");

			//取值为Y时，表示查询允许访问的协作应用集合；取值为N时，表示查询不允许访问的协作应用集合
			String json="json";
			String rev=addUser(host,desKey,appName,json,userMap);
			//System.out.println("res:"+receive(rev,desKey));
			return receive(rev, desKey);
		}
		return "{}";
	}

	/**
	 * @author LPH,查询ids全部应用
	 * @param host
	 * @param appName
	 * @param desKey
	 * @return
	 * @throws NoSuchAlgorithmException
	 * @throws UnsupportedEncodingException
	 */
	public static String queryUserManagerApp(String host,String desKey,String appName,String type,String userName,String password) throws NoSuchAlgorithmException, UnsupportedEncodingException{
		// 1、将所有参数以key-value的形式拼成整串，内隔符分别为=外分隔符&。
		StringBuffer sb=new StringBuffer(100);
		sb.append("userName=").append(userName).append("&password=").append(password);
		String data=sb.toString();
		// 2、根据整串生成摘要签名
		MessageDigest md = MessageDigest.getInstance("MD5");
		md.update(data.getBytes("UTF-8"));
		byte[] digestByte = md.digest();
		// 2-1）将生成的摘要转成16进制数表示
		//String digest = DESUtil.encodeHex(digestByte);
		String digest = DESUtil.bytesToHex(digestByte);
		// 3、对整串进行加密处理
		// 3-1）对整串做base64编码（去编码化）
		String base64Encoded = new String(Base64.encodeBase64(data.getBytes("UTF-8")));
		// 3-3）对data进行加密处理  并将结果转换成16进制表示
		String dataAfterDESEncode = DESUtil.encryptToHex(desKey,base64Encoded.getBytes("UTF-8"));
		// 4、将摘要签名和加密后的参数拼接成最终提交IDS的参数
		String finalData = digest+"&"+dataAfterDESEncode;
		String url=host+"/service?idsServiceType=remoteapi&method=listManageableCoApps";
		List<NameValuePair> formparams=new ArrayList<NameValuePair>();
		formparams.add(new BasicNameValuePair("appName",appName));
		formparams.add(new BasicNameValuePair("type",type));
		formparams.add(new BasicNameValuePair("version","5.0"));
		formparams.add(new BasicNameValuePair("data",finalData));
		return httpClientPost(url, formparams);
	}

	/**
	 * 修改用户
	 * @throws IOException
	 * @throws NoSuchAlgorithmException
	 */
	public static String currentEditUserManager(Map<String,Object> userMap) throws IOException, NoSuchAlgorithmException {
		Properties properties=new Properties();
		try{
			properties.load(IdsUtilForClient.class.getClassLoader().getResourceAsStream("trsids-agent.properties"));
		}catch (IOException	 e){
			log.info("------ids配置文件不存在------");
		}
		if(properties!=null){
			String host=properties.getProperty("protocol.http.url");
			host=host.replace("/protocol","");
			String appName=properties.getProperty("agent.name");

			//取值为Y时，表示查询允许访问的协作应用集合；取值为N时，表示查询不允许访问的协作应用集合
			String json="json";
			String rev=editUserManager(host,desKey,appName,json,userMap);
			//System.out.println("res:"+receive(rev,desKey));
			return receive(rev, desKey);
		}
		return "{}";
	}

	/**
	 * 管理员查询用户在ids的应用的权限(允许访问的或不允许访问的)
	 * @throws IOException
	 * @throws NoSuchAlgorithmException
	 */
	public static String currentQueryUserManagerApp(String userName,String password) throws IOException, NoSuchAlgorithmException {
		Properties properties=new Properties();
		try{
			properties.load(IdsUtilForClient.class.getClassLoader().getResourceAsStream("trsids-agent.properties"));
		}catch (IOException	 e){
			log.info("------ids配置文件不存在------");
		}
		if(properties!=null){
			String host=properties.getProperty("protocol.http.url");
			host=host.replace("/protocol","");
			String appName=properties.getProperty("agent.name");

			//取值为Y时，表示查询允许访问的协作应用集合；取值为N时，表示查询不允许访问的协作应用集合
			String json="json";
			String rev=queryUserManagerApp(host,desKey,appName,json,userName,password);
			//System.out.println("res:"+receive(rev,desKey));
			return receive(rev, desKey);
		}
		return "{}";
	}

	/**
	 * @author LPH,修改用户密码
	 * @param host
	 * @param appName
	 * @param desKey
	 * @return
	 * @throws NoSuchAlgorithmException
	 * @throws UnsupportedEncodingException
	 */
	public static String editUserPassword(String host,String desKey,String appName,String type,String userName,String oldPwd,String newPwd) throws NoSuchAlgorithmException, UnsupportedEncodingException{
		// 1、将所有参数以key-value的形式拼成整串，内隔符分别为=外分隔符&。
		StringBuffer sb=new StringBuffer(100);
		sb.append("attrName=userName").append("&attrValue=").append(userName).append("&oldPassword=").append(oldPwd)
				.append("&newPassword=").append(newPwd).append("&ensurePassword=").append(newPwd);
		String data=sb.toString();
		// 2、根据整串生成摘要签名
		MessageDigest md = MessageDigest.getInstance("MD5");
		md.update(data.getBytes("UTF-8"));
		byte[] digestByte = md.digest();
		// 2-1）将生成的摘要转成16进制数表示
		//String digest = DESUtil.encodeHex(digestByte);
		String digest = DESUtil.bytesToHex(digestByte);
		// 3、对整串进行加密处理
		// 3-1）对整串做base64编码（去编码化）
		String base64Encoded = new String(Base64.encodeBase64(data.getBytes("UTF-8")));
		// 3-3）对data进行加密处理  并将结果转换成16进制表示
		String dataAfterDESEncode = DESUtil.encryptToHex(desKey,base64Encoded.getBytes("UTF-8"));
		// 4、将摘要签名和加密后的参数拼接成最终提交IDS的参数
		String finalData = digest+"&"+dataAfterDESEncode;
		String url=host+"/service?idsServiceType=remoteapi&method=pwdReset";
		List<NameValuePair> formparams=new ArrayList<NameValuePair>();
		formparams.add(new BasicNameValuePair("appName",appName));
		formparams.add(new BasicNameValuePair("type",type));
		formparams.add(new BasicNameValuePair("version","5.0"));
		formparams.add(new BasicNameValuePair("data",finalData));
		return httpClientPost(url, formparams);
	}


	/**
	 * 修改用户密码
	 * @throws IOException
	 * @throws NoSuchAlgorithmException
	 */
	public static String currentEditUserPassword(String userName,String oldPwd,String newPwd) throws IOException, NoSuchAlgorithmException {
		Properties properties=new Properties();
		try{
			properties.load(IdsUtilForClient.class.getClassLoader().getResourceAsStream("trsids-agent.properties"));
		}catch (IOException	 e){
			log.info("------ids配置文件不存在------");
		}
		if(properties!=null){
			String host=properties.getProperty("protocol.http.url");
			host=host.replace("/protocol","");
			String appName=properties.getProperty("agent.name");

			//取值为Y时，表示查询允许访问的协作应用集合；取值为N时，表示查询不允许访问的协作应用集合
			String json="json";
			String rev=editUserPassword(host,desKey,appName,json,userName,oldPwd,newPwd);
			//System.out.println("res:"+receive(rev,desKey));
			return receive(rev, desKey);
		}
		return "{}";
	}

	/**
	 * @author LPH,检验唯一属性服务
	 * @param host
	 * @param objectName:如校验用户属性则为 “User”组织“Group”等“CoApp”
	 * @param attributeName
	 * @param attributeValue
	 * @return
	 * @throws NoSuchAlgorithmException
	 * @throws UnsupportedEncodingException
	 */
	public static String checkUniqueProperty(String host,String desKey,String appName,String type,String objectName,String attributeName,String attributeValue) throws NoSuchAlgorithmException, UnsupportedEncodingException{
		// 1、将所有参数以key-value的形式拼成整串，内隔符分别为=外分隔符&。
		StringBuffer sb=new StringBuffer(100);
		sb.append("objectName=").append(objectName).append("&attributeName=").append(attributeName)
				.append("&attributeValue=").append(attributeValue);
		String data=sb.toString();
		// 2、根据整串生成摘要签名
		MessageDigest md = MessageDigest.getInstance("MD5");
		md.update(data.getBytes("UTF-8"));
		byte[] digestByte = md.digest();
		// 2-1）将生成的摘要转成16进制数表示
		//String digest = DESUtil.encodeHex(digestByte);
		String digest = DESUtil.bytesToHex(digestByte);
		// 3、对整串进行加密处理
		// 3-1）对整串做base64编码（去编码化）
		String base64Encoded = new String(Base64.encodeBase64(data.getBytes("UTF-8")));
		// 3-3）对data进行加密处理  并将结果转换成16进制表示
		String dataAfterDESEncode = DESUtil.encryptToHex(desKey,base64Encoded.getBytes("UTF-8"));
		// 4、将摘要签名和加密后的参数拼接成最终提交IDS的参数
		String finalData = digest+"&"+dataAfterDESEncode;
		String url=host+"/service?idsServiceType=remoteapi&method=checkAttributeUnique";
		List<NameValuePair> formparams=new ArrayList<NameValuePair>();
		formparams.add(new BasicNameValuePair("appName",appName));
		formparams.add(new BasicNameValuePair("type",type));
		formparams.add(new BasicNameValuePair("version","5.0"));
		formparams.add(new BasicNameValuePair("data",finalData));
		return httpClientPost(url, formparams);
	}

	/**
	 * 检验唯一属性服务
	 * @throws IOException
	 * @throws NoSuchAlgorithmException
	 */
	public static String currentCheckUniqueProperty(String objectName,String attributeName,String attributeValue) throws IOException, NoSuchAlgorithmException {
		Properties properties=new Properties();
		try{
			properties.load(IdsUtilForClient.class.getClassLoader().getResourceAsStream("trsids-agent.properties"));
		}catch (IOException	 e){
			log.info("------ids配置文件不存在------");
		}
		if(properties!=null){
			String host=properties.getProperty("protocol.http.url");
			host=host.replace("/protocol","");
			String appName=properties.getProperty("agent.name");

			//取值为Y时，表示查询允许访问的协作应用集合；取值为N时，表示查询不允许访问的协作应用集合
			String json="json";
			String rev=checkUniqueProperty(host,desKey,appName,json,objectName,attributeName,attributeValue);
			//System.out.println("res:"+receive(rev,desKey));
			return receive(rev, desKey);
		}
		return "{}";
	}

	/**
	 * @author LPH,为  用户取消  应用权限
	 * @param host
	 * @param userName
	 * @param coAppName
	 * @return
	 * @throws NoSuchAlgorithmException
	 * @throws UnsupportedEncodingException
	 */
	public static String reduceUserAccessApp(String host,String desKey,String appName,String type
			,String userName,String coAppName) throws NoSuchAlgorithmException, UnsupportedEncodingException{
		// 1、将所有参数以key-value的形式拼成整串，内隔符分别为=外分隔符&。
		StringBuffer sb=new StringBuffer(100);
		sb.append("&userName=").append(userName).append("&coAppName=").append(coAppName);
		String data=sb.toString();
		// 2、根据整串生成摘要签名
		MessageDigest md = MessageDigest.getInstance("MD5");
		md.update(data.getBytes("UTF-8"));
		byte[] digestByte = md.digest();
		// 2-1）将生成的摘要转成16进制数表示
		//String digest = DESUtil.encodeHex(digestByte);
		String digest = DESUtil.bytesToHex(digestByte);
		// 3、对整串进行加密处理
		// 3-1）对整串做base64编码（去编码化）
		String base64Encoded = new String(Base64.encodeBase64(data.getBytes("UTF-8")));
		// 3-3）对data进行加密处理  并将结果转换成16进制表示
		String dataAfterDESEncode = DESUtil.encryptToHex(desKey,base64Encoded.getBytes("UTF-8"));
		// 4、将摘要签名和加密后的参数拼接成最终提交IDS的参数
		String finalData = digest+"&"+dataAfterDESEncode;
		String url=host+"/service?idsServiceType=remoteapi&method=reduceUserAccessApp";
		List<NameValuePair> formparams=new ArrayList<NameValuePair>();
		formparams.add(new BasicNameValuePair("appName",appName));
		formparams.add(new BasicNameValuePair("type",type));
		formparams.add(new BasicNameValuePair("version","5.0"));
		formparams.add(new BasicNameValuePair("data",finalData));
		return httpClientPost(url, formparams);
	}

	/**
	 * 为  用户添加  应用权限
	 * @throws IOException
	 * @throws NoSuchAlgorithmException
	 */
	public static String currentAssignAppsForUsersManager(String userNames,String coAppNames) throws IOException, NoSuchAlgorithmException {
		Properties properties=new Properties();
		try{
			properties.load(IdsUtilForClient.class.getClassLoader().getResourceAsStream("trsids-agent.properties"));
		}catch (IOException	 e){
			log.info("------ids配置文件不存在------");
		}
		if(properties!=null){
			String host=properties.getProperty("protocol.http.url");
			host=host.replace("/protocol","");
			String appName=properties.getProperty("agent.name");

			//取值为Y时，表示查询允许访问的协作应用集合；取值为N时，表示查询不允许访问的协作应用集合
			String json="json";
			String rev=assignAppsForUsersManager(host,desKey,appName,json,userNames,coAppNames);
			//System.out.println("res:"+receive(rev,desKey));
			return receive(rev, desKey);
		}
		return "{}";
	}

	/**
	 * @author LPH,为  用户添加  应用权限
	 * @param host
	 * @param userNames
	 * @param coAppNames
	 * @return
	 * @throws NoSuchAlgorithmException
	 * @throws UnsupportedEncodingException
	 */
	public static String assignAppsForUsersManager(String host,String desKey,String appName,String type
			,String userNames,String coAppNames) throws NoSuchAlgorithmException, UnsupportedEncodingException{
		// 1、将所有参数以key-value的形式拼成整串，内隔符分别为=外分隔符&。
		StringBuffer sb=new StringBuffer(100);
		sb.append("&userNames=").append(userNames).append("&coAppNames=").append(coAppNames);
		String data=sb.toString();
		// 2、根据整串生成摘要签名
		MessageDigest md = MessageDigest.getInstance("MD5");
		md.update(data.getBytes("UTF-8"));
		byte[] digestByte = md.digest();
		// 2-1）将生成的摘要转成16进制数表示
		//String digest = DESUtil.encodeHex(digestByte);
		String digest = DESUtil.bytesToHex(digestByte);
		// 3、对整串进行加密处理
		// 3-1）对整串做base64编码（去编码化）
		String base64Encoded = new String(Base64.encodeBase64(data.getBytes("UTF-8")));
		// 3-3）对data进行加密处理  并将结果转换成16进制表示
		String dataAfterDESEncode = DESUtil.encryptToHex(desKey,base64Encoded.getBytes("UTF-8"));
		// 4、将摘要签名和加密后的参数拼接成最终提交IDS的参数
		String finalData = digest+"&"+dataAfterDESEncode;
		String url=host+"/service?idsServiceType=remoteapi&method=assignAppsForUsers";
		List<NameValuePair> formparams=new ArrayList<NameValuePair>();
		formparams.add(new BasicNameValuePair("appName",appName));
		formparams.add(new BasicNameValuePair("type",type));
		formparams.add(new BasicNameValuePair("version","5.0"));
		formparams.add(new BasicNameValuePair("data",finalData));
		return httpClientPost(url, formparams);
	}

	/**
	 * 为  用户取消  应用权限
	 * @throws IOException
	 * @throws NoSuchAlgorithmException
	 */
	public static String currentReduceUserAccessApp(String userName,String coAppName) throws IOException, NoSuchAlgorithmException {
		Properties properties=new Properties();
		try{
			properties.load(IdsUtilForClient.class.getClassLoader().getResourceAsStream("trsids-agent.properties"));
		}catch (IOException	 e){
			log.info("------ids配置文件不存在------");
		}
		if(properties!=null){
			String host=properties.getProperty("protocol.http.url");
			host=host.replace("/protocol","");
			String appName=properties.getProperty("agent.name");

			//取值为Y时，表示查询允许访问的协作应用集合；取值为N时，表示查询不允许访问的协作应用集合
			String json="json";
			String rev=reduceUserAccessApp(host,desKey,appName,json,userName,coAppName);
			//System.out.println("res:"+receive(rev,desKey));
			return receive(rev, desKey);
		}
		return "{}";
	}

	/**
	 * @author LPH,为  禁用启用用户
	 * @param host
	 * @param userName
	 * @param operator
	 * @return
	 * @throws NoSuchAlgorithmException
	 * @throws UnsupportedEncodingException
	 */
	public static String activeOrStopUser(String host,String desKey,String appName,String type
			,String userName,String operator) throws NoSuchAlgorithmException, UnsupportedEncodingException{
		// 1、将所有参数以key-value的形式拼成整串，内隔符分别为=外分隔符&。
		StringBuffer sb=new StringBuffer(100);
		sb.append("&userName=").append(userName).append("&operator=").append(operator);
		String data=sb.toString();
		// 2、根据整串生成摘要签名
		MessageDigest md = MessageDigest.getInstance("MD5");
		md.update(data.getBytes("UTF-8"));
		byte[] digestByte = md.digest();
		// 2-1）将生成的摘要转成16进制数表示
		//String digest = DESUtil.encodeHex(digestByte);
		String digest = DESUtil.bytesToHex(digestByte);
		// 3、对整串进行加密处理
		// 3-1）对整串做base64编码（去编码化）
		String base64Encoded = new String(Base64.encodeBase64(data.getBytes("UTF-8")));
		// 3-3）对data进行加密处理  并将结果转换成16进制表示
		String dataAfterDESEncode = DESUtil.encryptToHex(desKey,base64Encoded.getBytes("UTF-8"));
		// 4、将摘要签名和加密后的参数拼接成最终提交IDS的参数
		String finalData = digest+"&"+dataAfterDESEncode;
		String url=host+"/service?idsServiceType=remoteapi&method=activeOrStopUser";
		List<NameValuePair> formparams=new ArrayList<NameValuePair>();
		formparams.add(new BasicNameValuePair("appName",appName));
		formparams.add(new BasicNameValuePair("type",type));
		formparams.add(new BasicNameValuePair("version","5.0"));
		formparams.add(new BasicNameValuePair("data",finalData));
		return httpClientPost(url, formparams);
	}

	/**
	 * 为  用户 禁用启用用户
	 * @throws IOException
	 * @throws NoSuchAlgorithmException
	 */
	public static String currentActiveOrStopUser(String userName,String operator) throws IOException, NoSuchAlgorithmException {
		Properties properties=new Properties();
		try{
			properties.load(IdsUtilForClient.class.getClassLoader().getResourceAsStream("trsids-agent.properties"));
		}catch (IOException	 e){
			log.info("------ids配置文件不存在------");
		}
		if(properties!=null){
			String host=properties.getProperty("protocol.http.url");
			host=host.replace("/protocol","");
			String appName=properties.getProperty("agent.name");

			//取值为Y时，表示查询允许访问的协作应用集合；取值为N时，表示查询不允许访问的协作应用集合
			String json="json";
			String rev=activeOrStopUser(host,desKey,appName,json,userName,operator);
			//System.out.println("res:"+receive(rev,desKey));
			return receive(rev, desKey);
		}
		return "{}";
	}

	/**
	 * @author 重置用户密码
	 * @param host
	 * @param appName
	 * @param desKey
	 * @return
	 * @throws NoSuchAlgorithmException
	 * @throws UnsupportedEncodingException
	 */
	public static String resetUserPassword(String host,String desKey,String appName,String type,String attrValue,String activationCode,String newPassword) throws NoSuchAlgorithmException, UnsupportedEncodingException{
		// 1、将所有参数以key-value的形式拼成整串，内隔符分别为=外分隔符&。
		StringBuffer sb=new StringBuffer(100);
		sb.append("attrName=userName").append("&attrValue=").append(attrValue).append("&activationCode=").append(activationCode)
				.append("&newPassword=").append(newPassword).append("&ensurePassword=").append(newPassword);
		String data=sb.toString();
		// 2、根据整串生成摘要签名
		MessageDigest md = MessageDigest.getInstance("MD5");
		md.update(data.getBytes("UTF-8"));
		byte[] digestByte = md.digest();
		// 2-1）将生成的摘要转成16进制数表示
		//String digest = DESUtil.encodeHex(digestByte);
		String digest = DESUtil.bytesToHex(digestByte);
		// 3、对整串进行加密处理
		// 3-1）对整串做base64编码（去编码化）
		String base64Encoded = new String(Base64.encodeBase64(data.getBytes("UTF-8")));
		// 3-3）对data进行加密处理  并将结果转换成16进制表示
		String dataAfterDESEncode = DESUtil.encryptToHex(desKey,base64Encoded.getBytes("UTF-8"));
		// 4、将摘要签名和加密后的参数拼接成最终提交IDS的参数
		String finalData = digest+"&"+dataAfterDESEncode;
		String url=host+"/service?idsServiceType=remoteapi&method=resetPwdv5";
		List<NameValuePair> formparams=new ArrayList<NameValuePair>();
		formparams.add(new BasicNameValuePair("appName",appName));
		formparams.add(new BasicNameValuePair("type",type));
		formparams.add(new BasicNameValuePair("version","5.0"));
		formparams.add(new BasicNameValuePair("data",finalData));
		return httpClientPost(url, formparams);
	}


	/**
	 * 重置用户密码
	 * @throws IOException
	 * @throws NoSuchAlgorithmException
	 */
	public static String currentResetUserPassword(String attrValue,String activationCode,String newPassword) throws IOException, NoSuchAlgorithmException {
		Properties properties=new Properties();
		try{
			properties.load(IdsUtilForClient.class.getClassLoader().getResourceAsStream("trsids-agent.properties"));
		}catch (IOException	 e){
			log.info("------ids配置文件不存在------");
		}
		if(properties!=null){
			String host=properties.getProperty("protocol.http.url");
			host=host.replace("/protocol","");
			String appName=properties.getProperty("agent.name");

			//取值为Y时，表示查询允许访问的协作应用集合；取值为N时，表示查询不允许访问的协作应用集合
			String json="json";
//			String rev=editUserPassword(host,desKey,appName,json,userName,oldPwd,newPwd);
			String rev=resetUserPassword(host,desKey,appName,json,attrValue,activationCode,newPassword);
//			System.out.println("res:"+receive(rev,desKey));
			return receive(rev, desKey);
		}
		return "{}";
	}

	/**
	 * @author LPH,查询用户
	 * @param host
	 * @param desKey
	 * @param appName
	 * @param type
	 * @param userName
	 * @return
	 * @throws NoSuchAlgorithmException
	 * @throws UnsupportedEncodingException
	 */
	public static String queryUserManager(String host,String desKey,String appName,String type,String userName) throws NoSuchAlgorithmException, UnsupportedEncodingException{
		// 1、将所有参数以key-value的形式拼成整串，内隔符分别为=外分隔符&。
		StringBuffer sb=new StringBuffer(100);
		sb.append("userName=");
		sb.append(userName);
		String data=sb.toString();
		// 2、根据整串生成摘要签名
		MessageDigest md = MessageDigest.getInstance("MD5");
		md.update(data.getBytes("UTF-8"));
		byte[] digestByte = md.digest();
		// 2-1）将生成的摘要转成16进制数表示
		//String digest = DESUtil.encodeHex(digestByte);
		String digest = DESUtil.bytesToHex(digestByte);
		// 3、对整串进行加密处理
		// 3-1）对整串做base64编码（去编码化）
		String base64Encoded = new String(Base64.encodeBase64(data.getBytes("UTF-8")));
		// 3-3）对data进行加密处理  并将结果转换成16进制表示
		String dataAfterDESEncode = DESUtil.encryptToHex(desKey,base64Encoded.getBytes("UTF-8"));
		// 4、将摘要签名和加密后的参数拼接成最终提交IDS的参数
		String finalData = digest+"&"+dataAfterDESEncode;
		String url=host+"/service?idsServiceType=remoteapi&method=userQueryForManage";
		List<NameValuePair> formparams=new ArrayList<NameValuePair>();
		formparams.add(new BasicNameValuePair("type",type));
		formparams.add(new BasicNameValuePair("appName",appName));
		formparams.add(new BasicNameValuePair("version","5.0"));
		formparams.add(new BasicNameValuePair("data",finalData));
		return httpClientPost(url, formparams);
	}

	/**
	 * 查询用户
	 * @throws IOException
	 * @throws NoSuchAlgorithmException
	 */
	public static String currentQueryUserManager(String userName) throws IOException, NoSuchAlgorithmException {
		Properties properties=new Properties();
		try{
			properties.load(IdsUtilForClient.class.getClassLoader().getResourceAsStream("trsids-agent.properties"));
		}catch (IOException	 e){
			log.info("------ids配置文件不存在------");
		}
		if(properties!=null){
			String host=properties.getProperty("protocol.http.url");
			host=host.replace("/protocol","");
			String appName=properties.getProperty("agent.name");

			//取值为Y时，表示查询允许访问的协作应用集合；取值为N时，表示查询不允许访问的协作应用集合
			String json="json";
			String rev=queryUserManager(host,desKey,appName,json,userName);
			//System.out.println("res:"+receive(rev,desKey));
			return receive(rev, desKey);
		}
		return "{}";
	}

	/**
	 * @author LPH,用户密码找回
	 * @param host
	 * @param appName
	 * @param desKey
	 * @return
	 * @throws NoSuchAlgorithmException
	 * @throws UnsupportedEncodingException
	 */
	public static String resetUserPwd(String host,String desKey,String appName,String type,String userName,String newPwd) throws NoSuchAlgorithmException, UnsupportedEncodingException{
		// 1、将所有参数以key-value的形式拼成整串，内隔符分别为=外分隔符&。
		StringBuffer sb=new StringBuffer(100);
		sb.append("userName=").append(userName).append("&newPwd=").append(newPwd)
				.append("&ensurePwd=").append(newPwd);
		String data=sb.toString();
		// 2、根据整串生成摘要签名
		MessageDigest md = MessageDigest.getInstance("MD5");
		md.update(data.getBytes("UTF-8"));
		byte[] digestByte = md.digest();
		// 2-1）将生成的摘要转成16进制数表示
		//String digest = DESUtil.encodeHex(digestByte);
		String digest = DESUtil.bytesToHex(digestByte);
		// 3、对整串进行加密处理
		// 3-1）对整串做base64编码（去编码化）
		String base64Encoded = new String(Base64.encodeBase64(data.getBytes("UTF-8")));
		// 3-3）对data进行加密处理  并将结果转换成16进制表示
		String dataAfterDESEncode = DESUtil.encryptToHex(desKey,base64Encoded.getBytes("UTF-8"));
		// 4、将摘要签名和加密后的参数拼接成最终提交IDS的参数
		String finalData = digest+"&"+dataAfterDESEncode;
		String url=host+"/service?idsServiceType=remoteapi&method=resetUserPwd";
		List<NameValuePair> formparams=new ArrayList<NameValuePair>();
		formparams.add(new BasicNameValuePair("appName",appName));
		formparams.add(new BasicNameValuePair("type",type));
		formparams.add(new BasicNameValuePair("version","5.0"));
		formparams.add(new BasicNameValuePair("data",finalData));
		return httpClientPost(url, formparams);
	}


	/**
	 * 用户密码找回
	 * @throws IOException
	 * @throws NoSuchAlgorithmException
	 */
	public static String currentResetUserPwd(String userName,String pwd) throws IOException, NoSuchAlgorithmException {
		Properties properties=new Properties();
		try{
			properties.load(IdsUtilForClient.class.getClassLoader().getResourceAsStream("trsids-agent.properties"));
		}catch (IOException	 e){
			log.info("------ids配置文件不存在------");
		}
		if(properties!=null){
			String host=properties.getProperty("protocol.http.url");
			host=host.replace("/protocol","");
			String appName=properties.getProperty("agent.name");

			//取值为Y时，表示查询允许访问的协作应用集合；取值为N时，表示查询不允许访问的协作应用集合
			String json="json";
			String rev=resetUserPwd(host,desKey,appName,json,userName,pwd);
			//System.out.println("res:"+receive(rev,desKey));
			return receive(rev, desKey);
		}
		return "{}";
	}

	public static void main(String[] args) throws NoSuchAlgorithmException, IOException {
		//查询用户应用权限
//		String receive = currentQueryUserAppPermit("SJPADMIN");
		//查询全部用户应用权限
		//String receive = currentQueryAllApp();
		//查询用户属性是否唯一,此处为用户名  userName  字段
		//String receive=currentCheckUniqueProperty("User","userName","1101");
		//取消授权
//		String receive=currentReduceUserAccessApp("1101","sjgxxt");
		//授权
//		String receive=currentAssignAppsForUsersManager("1101","sjgxxt");
		//禁用启用用户
//		String receive=currentActiveOrStopUser("test","true");
		String receive=currentQueryUserManager("test");
//		String receive=currentResetUserPwd("czmmcs","123456789");
		//新增用户
		/*Map<String,Object> map=new HashMap<>();
		map.put("userName","test"+ DateTool.getSysDateTimeStr("yyyyMMdd"));
		map.put("password","12345678");
		map.put("firstName","姓");
		map.put("lastName","名");
		map.put("email","123@qq.com");
		map.put("nickName","昵称");
		map.put("position","岗位");
		map.put("tel","7968688");
		map.put("trueName","中文名");
		map.put("groupName","11");
		String receive = currentAddUser(map);*/
		System.out.println( receive );
	}
}
