package com.unis.auth.utils;

import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.stereotype.Component;

/**
 * Spring工具类
 * @author lxy
 *
 */
@Component
public class SpringUtil implements ApplicationContextAware {
    private static ApplicationContext applicationContext ;

    @Override
    public void setApplicationContext(ApplicationContext arg0) throws BeansException {
        SpringUtil.applicationContext = arg0;
    }

    // 获取applicationContext
    public static ApplicationContext getApplicationContext() {
        return SpringUtil.applicationContext;
    }

    // 通过name获取 Bean.
    public static Object getBean(String name) {
        return getApplicationContext().getBean(name);
    }

    // 通过class获取Bean.
    public static <T> T getBean(Class<T> clazz) {
        return getApplicationContext().getBean(clazz);
    }

    // 通过class获取Bean.
    public static void  getBeanDefinitionNames() {
        System.out.println("getApplicationContext:"+(getApplicationContext()==null));
        String[] strArr= getApplicationContext().getBeanDefinitionNames();
        int len=strArr.length;
        System.out.println("--------"+len+"----------");
        for(int i=0;i<len;i++){
            System.out.println(strArr[i]);
        }
    }

    // 通过name,以及Clazz返回指定的Bean
    public static <T> T getBean(String name, Class<T> clazz) {
        return getApplicationContext().getBean(name, clazz);
    }

}